﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinDataSource;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace WindowsFormsApplication31
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.ultraGrid1.CreationFilter = new MyBandHeaderCreationFilter();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            for (int i = 0; i < 5; i++)
            {
                UltraDataRow parentRow = this.ultraDataSource1.Rows.Add(new object[] { i, "Parent Row " + i.ToString() });
                for (int j = 0; j < 3; j++)
                {
                    parentRow.GetChildRows(0).Add(new object[] { j, "ChildRow " + j.ToString() });
                }
            }
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            foreach (UltraGridBand band in layout.Bands)
            {
                band.HeaderVisible = true;
            }            
        }
    }

    public class MyBandHeaderCreationFilter : IUIElementCreationFilter
    {
        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            TextUIElement textElement = parent as TextUIElement;
            if (null == textElement)
                return;

            BandHeadersUIElement bandHeadersUIElement = textElement.GetAncestor(typeof(BandHeadersUIElement)) as BandHeadersUIElement;
            if (null == bandHeadersUIElement)
                return;

            UltraGridRow row = bandHeadersUIElement.GetContext(typeof(UltraGridRow)) as UltraGridRow;
            if (null == row)
                return;

            UltraGridRow parentRow = row.ParentRow;
            if (null == parentRow)
                return;

            // If we get here, it means that we are creating a text element for a band header
            // in a child band. So set the text of the element based on the parent row. 
            textElement.Text = parentRow.Cells["Column 1"].Text;
        }

        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            // Do nothing.
            return false;
        }
    }

}
